<template>
  <div class="app-container">
    <div class="operation">
      <el-button v-if="isRoleEdit" class="success" style="float: left;margin-right:10px;" @click="form_add">新增</el-button>
      <el-button v-if="isRoleEdit" class="danger" style="float: left;margin-right:10px;" @click="handleDelete">删除</el-button>
      <el-button v-if="isRoleEdit" class="warning" style="float: left;margin-right:10px;" @click="handleCopy">复制</el-button>
      <el-button v-if="isRoleEdit" class="import" style="float: right;" @click="form_inport">导入</el-button>
      <el-dropdown style="float: right;margin-right: 10px;">
        <el-button class="export">导出</el-button>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item @click.native="form_export(1)">导出模板</el-dropdown-item>
          <el-dropdown-item @click.native="form_export(2)">导出数据</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>

    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.barid" filterable placeholder="栏舍名称" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="(item,index) in houseNameList" :key="index" :label="item.bname" :value="item.id" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.cowclass" filterable placeholder="牲畜类别" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="(item,index) in livestockList" :key="index" :label="item.mixname" :value="item.classname" />
      </el-select>
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="form_clear">重置</el-button>
    </div>
    <div class="table">
      <el-table :key="table.tableKey" v-loading="table.listLoading" element-loading-text="给我一点时间" :data="table.list" border fit highlight-current-row style="width: 100%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed" @selection-change="change_table_selection">
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="栏舍名称" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.barname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="牲畜类别" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.cowclass }}</span>
          </template>
        </el-table-column>
        <el-table-column label="牛头数" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.cowsum }}</span>
          </template>
        </el-table-column>
        <el-table-column label="月龄" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.avgmonthage }}</span>
          </template>
        </el-table-column>
        <el-table-column label="体重(kg)" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.bw }}</span>
          </template>
        </el-table-column>
        <el-table-column label="日增重(kg)" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.dayw }}</span>
          </template>
        </el-table-column>
        <el-table-column label="胎次" min-width="80px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.fetal }}</span>
          </template>
        </el-table-column>
        <el-table-column label="平均泌乳天数" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.avgdim }}</span>
          </template>
        </el-table-column>
        <el-table-column label="怀孕天数" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.dayspre }}</span>
          </template>
        </el-table-column>
        <el-table-column label="产奶量(kg/头)" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.product }}</span>
          </template>
        </el-table-column>
        <el-table-column label="乳脂率(%)" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.fat }}</span>
          </template>
        </el-table-column>
        <el-table-column label="乳蛋白率(%)" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.pro }}</span>
          </template>
        </el-table-column>
        <el-table-column label="乳糖率(%)" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.lactose }}</span>
          </template>
        </el-table-column>
        <el-table-column label="温度(℃)" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.tem }}</span>
          </template>
        </el-table-column>
        <el-table-column label="记录人" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.emp }}</span>
          </template>
        </el-table-column>
        <el-table-column label="生效时间" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.productdate }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="250" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="isRoleEdit" class="miniSuccess" @click="form_edit(row)">编辑</el-button>
            <el-button v-if="isRoleEdit" class="miniDanger" @click="form_delete(row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="get_table_data" />
    </div>

    <el-dialog :title="textMap[create.dialogStatus]" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <div class="app-add">
        <el-form ref="temp" :rules="create.rules" :model="create.temp" label-position="right" label-width="135px" style="width: 100%;margin:0 auto 50px">
          <el-row>
            <el-col :span="6">
              <el-form-item label="生效日期：" prop="productdate">
                <el-date-picker v-model="create.temp.productdate" type="date" placeholder="选择日期" format="yyyy-MM-dd" value-format="yyyy-MM-dd" style="width: 100%;" :clearable="false" :disabled="create.dialogStatus=='update'" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="记录人：" prop="emp">
                <el-select ref="emp" v-model="create.temp.emp" :disabled="create.dialogStatus=='update'" filterable placeholder="记录人" class="filter-item" style="width: 100%;" @blur="blurEmp">
                  <el-option v-for="(item,index) in create.noteTakerList" :key="item.myId" :label="item.emp" :value="item.emp" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <h3 style="width: 160px;text-align: right;">栏舍信息</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="栏舍名称：" prop="barid">
                <el-select v-model="create.temp.barid" :disabled="create.dialogStatus=='update'" filterable placeholder="栏舍名称" class="filter-item" style="width: 100%;" @change="change_bar">
                  <el-option v-for="(item,index) in houseNameList" :key="index" :label="item.bname" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="牲畜类别：" prop="cowclassid">
                <el-select v-model="create.temp.cowclassid" :disabled="create.dialogStatus=='update'" filterable placeholder="牲畜类别" class="filter-item" style="width: 100%;" @change="changeCowclass">
                  <el-option v-for="(item,index) in livestockList" :key="index" :label="item.mixname" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="牛头数：" prop="cowsum">
                <el-input ref="cowsum" v-model="create.temp.cowsum" class="filter-item" placeholder="正整数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="环境温度（℃）：" prop="tem">
                <el-input v-model="create.temp.tem" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <h3 style="width: 160px;text-align: right;">牛只基础信息</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="平均月龄：" prop="avgmonthage">
                <el-input ref="avgmonthage" v-model="create.temp.avgmonthage" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="体重（kg）:" prop="bw">
                <el-input ref="bw" v-model="create.temp.bw" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="日增重（kg）:" prop="dayw">
                <el-input ref="dayw" v-model="create.temp.dayw" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="怀孕天数：" prop="dayspre">
                <el-input ref="dayspre" v-model="create.temp.dayspre" class="filter-item" placeholder="0-280整数" type="number" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="胎次：" prop="fetal">
                <el-input ref="fetal" v-model="create.temp.fetal" :disabled="create.temp.bigcowclass=='后备牛' " class="filter-item" placeholder="0-20整数" type="number" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="平均泌乳天数：" prop="avgdim">
                <el-input ref="avgdim" v-model="create.temp.avgdim" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="正整数" type="number" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="产奶量（kg/头）：" prop="product">
                <el-input ref="product" v-model="create.temp.product" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="最多两位小数" type="number" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="乳脂率（%）" prop="fat">
                <el-input ref="fat" v-model="create.temp.fat" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="最多两位小数" type="number" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="乳蛋白率（%）：" prop="pro">
                <el-input ref="pro" v-model="create.temp.pro" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="最多两位小数" type="number" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="乳糖率（%）：" prop="lactose">
                <el-input ref="lactose" v-model="create.temp.lactose" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="最多两位小数" type="number" />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button class="cancelClose" @click="create.dialogFormVisible = false;get_table_data()">关闭</el-button>
          <el-button v-if="create.dialogStatus==='create'" class="success" :disabled="isokDisable" @click="add_dialog_saveAgain()">确认新增</el-button>
          <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="success" :disabled="isokDisable" @click="create.dialogStatus==='create'?add_dialog_save():form_edit_save()">确认</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, PostDataByName, failproccess, ExecDataByConfig, GetDataByNames, checkButtons, calculativeWidth } from '@/api/common'
import Cookies from 'js-cookie'
import { parseTime } from '@/utils/index.js'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
export default {
  name: 'Performance',
  components: { Pagination },
  data() {
    return {
      isRoleEdit: [],
      send_select_list: [
        { name: 'getBarListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') } },
        { name: 'getCowclassListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') } }
      ],
      houseNameList: [], // 栏舍名称
      livestockList: [], // 牲畜类别

      table: {
        getdataListParm: {
          name: 'getBarmilkList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            cowclass: '',
            startTime: '',
            stopTime: '',
            inputDatetime: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },

      // 新增/编辑
      create: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: { pastureid: Cookies.get('pastureid'), productdate: parseTime(new Date(), '{y}-{m}-{d}'), emp: Cookies.get('employename'), barid: '', barname: '', cowclassid: '', cowclass: '', bigcowclass: '', cowsum: '', tem: '', avgmonthage: '', bw: '', dayw: '', dayspre: '', fetal: '', avgdim: '', product: '', fat: '', pro: '', lactose: '' },
        rules: {
          barid: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          cowclassid: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }]
        },
        getdataListParm: {
          name: 'getBarmilkEmpHis',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        noteTakerList: [] // 记录人
      },
      textMap: {
        create: '新增',
        update: '编辑'
      },

      requestParam: {},
      isokDisable: false,
      selectList: [],
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' }
    }
  },

  created() {
    this.get_table_data()
    this.get_select_list()
    this.get_auto_buttons()
  },
  methods: {
    get_auto_buttons() {
      const Edit = 'Performance'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    get_select_list() {
      GetDataByNames(this.send_select_list).then(response => {
        this.houseNameList = response.data.getBarListEnable.list
        this.livestockList = response.data.getCowclassListEnable.list
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    get_table_data() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },
    form_clear() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.barid = ''
      this.table.getdataListParm.parammaps.cowclass = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },

    // 新增
    form_reset() {
      this.create.temp = { pastureid: Cookies.get('pastureid'), productdate: parseTime(new Date(), '{y}-{m}-{d}'), emp: Cookies.get('employename'), barid: '', barname: '', cowclassid: '', cowclass: '', bigcowclass: '', cowsum: '', tem: '', avgmonthage: '', bw: '', dayw: '', dayspre: '', fetal: '', avgdim: '', product: '', fat: '', pro: '', lactose: '' }
    },
    blurEmp(item) {
      this.create.temp.emp = item.target.value
    },
    // 栏舍名称
    change_bar(item) {
      this.create.temp.barname = this.houseNameList.find(obj => obj.id === item).bname
    },
    // 牲畜类别
    changeCowclass(item) {
      this.create.temp.cowclass = this.livestockList.find(obj => obj.id === item).classname
      this.create.temp.bigcowclass = this.livestockList.find(obj => obj.id === item).parentname
    },
    getNoteTakerList() {
      GetDataByName(this.create.getdataListParm).then(response => {
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            response.data.list[i].myId = i
          }
          this.create.noteTakerList = response.data.list
          console.log('记录人数据', response.data.list)
          console.log(this.create.noteTakerList)
        } else {
          this.create.noteTakerList = []
        }
      })
    },
    form_add() {
      console.log('点击了新增')
      this.form_reset()
      this.getNoteTakerList()
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
    },
    add_dialog_save() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const positiveInteger = /^[1-9]\d*$/
          // 牛头数
          if (this.create.temp.cowsum !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.cowsum))) {
              this.$message({ type: 'error', message: '牛头数请输入正整数', duration: 2000 })
              return false
            }
          }
          const twoDecimalPlaces = /^\d+(\.\d{1,2})?$/
          // 温度环境
          if (this.create.temp.tem !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.tem))) {
              this.$message({ type: 'error', message: '温度环境请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 平均月龄
          if (this.create.temp.avgmonthage !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.avgmonthage))) {
              this.$message({ type: 'error', message: '平均月龄请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 体重
          if (this.create.temp.bw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.bw))) {
              this.$message({ type: 'error', message: '体重请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 日增重
          if (this.create.temp.dayw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.dayw))) {
              this.$message({ type: 'error', message: '日增重请保留两位小数', duration: 2000 })
              return false
            }
          }
          const dayspre = /^(([0-9]|([1-9]\d)|(1\d\d)|(2([0-7]\d|7[0-9]))))$/
          // 怀孕天数
          if (this.create.temp.dayspre !== '') {
            if (!dayspre.test(parseFloat(this.create.temp.dayspre))) {
              this.$message({ type: 'error', message: '怀孕天数请输入大于0小于280整数', duration: 2000 })
              return false
            }
          }
          const fetal = /^(?:[0-9]|1[0-9])$/
          // 胎次
          if (this.create.temp.fetal !== '') {
            if (!fetal.test(parseFloat(this.create.temp.fetal))) {
              this.$message({ type: 'error', message: '胎次请输入大于0小于20整数', duration: 2000 })
              return false
            }
          }
          // 平均泌乳
          if (this.create.temp.avgdim !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.avgdim))) {
              this.$message({ type: 'error', message: '平均泌乳天数请输入正整数', duration: 2000 })
              return false
            }
          }
          // 产奶量
          if (this.create.temp.product !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.product))) {
              this.$message({ type: 'error', message: '产奶量请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳脂率
          if (this.create.temp.fat !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.fat))) {
              this.$message({ type: 'error', message: '乳脂率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳蛋白率
          if (this.create.temp.pro !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.pro))) {
              this.$message({ type: 'error', message: '乳蛋白率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳糖率
          if (this.create.temp.lactose !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.lactose))) {
              this.$message({ type: 'error', message: '乳糖率请保留两位小数', duration: 2000 })
              return false
            }
          }

          this.requestParam.name = 'insertBarmilk'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.cowsum == '') { this.create.temp.cowsum = '0' }
          if (this.create.temp.tem == '') { this.create.temp.tem = '0' }
          if (this.create.temp.avgmonthage == '') { this.create.temp.avgmonthage = '0' }
          if (this.create.temp.bw == '') { this.create.temp.bw = '0' }
          if (this.create.temp.dayw == '') { this.create.temp.dayw = '0' }
          if (this.create.temp.dayspre == '') { this.create.temp.dayspre = '0' }
          if (this.create.temp.fetal == '') { this.create.temp.fetal = '0' }
          if (this.create.temp.avgdim == '') { this.create.temp.avgdim = '0' }
          if (this.create.temp.product == '') { this.create.temp.product = '0' }
          if (this.create.temp.fat == '') { this.create.temp.fat = '0' }
          if (this.create.temp.pro == '') { this.create.temp.pro = '0' }
          if (this.create.temp.lactose == '') { this.create.temp.lactose = '0' }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.get_table_data()
            } else {
              const barid = new RegExp("key 'barid'")
              if (barid.test(response.data)) {
                this.$message({ type: 'error', message: '该栏舍今日生产性能已存在，不可重复生成', duration: 2000 })
              } else {
                failproccess(response, this.$notify)
              }
              if (this.create.temp.cowsum == '0') { this.create.temp.cowsum = '' }
              if (this.create.temp.tem == '0') { this.create.temp.tem = '' }
              if (this.create.temp.avgmonthage == '0') { this.create.temp.avgmonthage = '' }
              if (this.create.temp.bw == '0') { this.create.temp.bw = '' }
              if (this.create.temp.dayw == '0') { this.create.temp.dayw = '' }
              if (this.create.temp.dayspre == '0') { this.create.temp.dayspre = '' }
              if (this.create.temp.fetal == '0') { this.create.temp.fetal = '' }
              if (this.create.temp.avgdim == '0') { this.create.temp.avgdim = '' }
              if (this.create.temp.product == '0') { this.create.temp.product = '' }
              if (this.create.temp.fat == '0') { this.create.temp.fat = '' }
              if (this.create.temp.pro == '0') { this.create.temp.pro = '' }
              if (this.create.temp.lactose == '0') { this.create.temp.lactose = '' }
            }
          })
        }
      })
    },
    add_dialog_saveAgain() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const positiveInteger = /^[1-9]\d*$/
          // 牛头数
          if (this.create.temp.cowsum !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.cowsum))) {
              this.$message({ type: 'error', message: '牛头数请输入正整数', duration: 2000 })
              return false
            }
          }
          const twoDecimalPlaces = /^\d+(\.\d{1,2})?$/
          // 温度环境
          if (this.create.temp.tem !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.tem))) {
              this.$message({ type: 'error', message: '温度环境请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 平均月龄
          if (this.create.temp.avgmonthage !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.avgmonthage))) {
              this.$message({ type: 'error', message: '平均月龄请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 体重
          if (this.create.temp.bw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.bw))) {
              this.$message({ type: 'error', message: '体重请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 日增重
          if (this.create.temp.dayw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.dayw))) {
              this.$message({ type: 'error', message: '日增重请保留两位小数', duration: 2000 })
              return false
            }
          }
          const dayspre = /^(([0-9]|([1-9]\d)|(1\d\d)|(2([0-7]\d|7[0-9]))))$/
          // 怀孕天数
          if (this.create.temp.dayspre !== '') {
            if (!dayspre.test(parseFloat(this.create.temp.dayspre))) {
              this.$message({ type: 'error', message: '怀孕天数请输入大于0小于280整数', duration: 2000 })
              return false
            }
          }
          const fetal = /^(?:[0-9]|1[0-9])$/
          // 胎次
          if (this.create.temp.fetal !== '') {
            if (!fetal.test(parseFloat(this.create.temp.fetal))) {
              this.$message({ type: 'error', message: '胎次请输入大于0小于20整数', duration: 2000 })
              return false
            }
          }
          // 平均泌乳
          if (this.create.temp.avgdim !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.avgdim))) {
              this.$message({ type: 'error', message: '平均泌乳天数请输入正整数', duration: 2000 })
              return false
            }
          }
          // 产奶量
          if (this.create.temp.product !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.product))) {
              this.$message({ type: 'error', message: '产奶量请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳脂率
          if (this.create.temp.fat !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.fat))) {
              this.$message({ type: 'error', message: '乳脂率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳蛋白率
          if (this.create.temp.pro !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.pro))) {
              this.$message({ type: 'error', message: '乳蛋白率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳糖率
          if (this.create.temp.lactose !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.lactose))) {
              this.$message({ type: 'error', message: '乳糖率请保留两位小数', duration: 2000 })
              return false
            }
          }

          this.requestParam.name = 'insertBarmilk'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.cowsum == '') { this.create.temp.cowsum = '0' }
          if (this.create.temp.tem == '') { this.create.temp.tem = '0' }
          if (this.create.temp.avgmonthage == '') { this.create.temp.avgmonthage = '0' }
          if (this.create.temp.bw == '') { this.create.temp.bw = '0' }
          if (this.create.temp.dayw == '') { this.create.temp.dayw = '0' }
          if (this.create.temp.dayspre == '') { this.create.temp.dayspre = '0' }
          if (this.create.temp.fetal == '') { this.create.temp.fetal = '0' }
          if (this.create.temp.avgdim == '') { this.create.temp.avgdim = '0' }
          if (this.create.temp.product == '') { this.create.temp.product = '0' }
          if (this.create.temp.fat == '') { this.create.temp.fat = '0' }
          if (this.create.temp.pro == '') { this.create.temp.pro = '0' }
          if (this.create.temp.lactose == '') { this.create.temp.lactose = '0' }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.form_reset()
              this.create.noteTakerList = []
              this.getNoteTakerList()
            } else {
              const barid = new RegExp("key 'barid'")
              if (barid.test(response.data)) {
                this.$message({ type: 'error', message: '该栏舍今日生产性能已存在，不可重复生成', duration: 2000 })
              } else {
                failproccess(response, this.$notify)
              }
              if (this.create.temp.cowsum == '0') { this.create.temp.cowsum = '' }
              if (this.create.temp.tem == '0') { this.create.temp.tem = '' }
              if (this.create.temp.avgmonthage == '0') { this.create.temp.avgmonthage = '' }
              if (this.create.temp.bw == '0') { this.create.temp.bw = '' }
              if (this.create.temp.dayw == '0') { this.create.temp.dayw = '' }
              if (this.create.temp.dayspre == '0') { this.create.temp.dayspre = '' }
              if (this.create.temp.fetal == '0') { this.create.temp.fetal = '' }
              if (this.create.temp.avgdim == '0') { this.create.temp.avgdim = '' }
              if (this.create.temp.product == '0') { this.create.temp.product = '' }
              if (this.create.temp.fat == '0') { this.create.temp.fat = '' }
              if (this.create.temp.pro == '0') { this.create.temp.pro = '' }
              if (this.create.temp.lactose == '0') { this.create.temp.lactose = '' }
            }
          })
        }
      })
    },

    // 编辑
    form_edit(row) {
      console.log('点击了编辑', row)
      row.barid = String(row.barid)
      row.cowclassid = String(row.cowclassid)
      this.create.temp = Object.assign({}, row)
      this.create.temp.id = row.id
      if (this.create.temp.cowsum == '0') { this.create.temp.cowsum = '' }
      if (this.create.temp.avgdim == '0') { this.create.temp.avgdim = '' }
      this.getNoteTakerList()
      this.create.dialogStatus = 'update'
      this.create.dialogFormVisible = true
    },
    form_edit_save() {
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const positiveInteger = /^[1-9]\d*$/
          // 牛头数
          if (this.create.temp.cowsum !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.cowsum))) {
              this.$message({ type: 'error', message: '牛头数请输入正整数', duration: 2000 })
              return false
            }
          }
          const twoDecimalPlaces = /^\d+(\.\d{1,2})?$/
          // 温度环境
          if (this.create.temp.tem !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.tem))) {
              this.$message({ type: 'error', message: '温度环境请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 平均月龄
          if (this.create.temp.avgmonthage !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.avgmonthage))) {
              this.$message({ type: 'error', message: '平均月龄请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 体重
          if (this.create.temp.bw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.bw))) {
              this.$message({ type: 'error', message: '体重请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 日增重
          if (this.create.temp.dayw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.dayw))) {
              this.$message({ type: 'error', message: '日增重请保留两位小数', duration: 2000 })
              return false
            }
          }
          const dayspre = /^(([0-9]|([1-9]\d)|(1\d\d)|(2([0-7]\d|7[0-9]))))$/
          // 怀孕天数
          if (this.create.temp.dayspre !== '') {
            if (!dayspre.test(parseFloat(this.create.temp.dayspre))) {
              this.$message({ type: 'error', message: '怀孕天数请输入大于0小于280整数', duration: 2000 })
              return false
            }
          }
          const fetal = /^(?:[0-9]|1[0-9])$/
          // 胎次
          if (this.create.temp.fetal !== '') {
            if (!fetal.test(parseFloat(this.create.temp.fetal))) {
              this.$message({ type: 'error', message: '胎次请输入大于0小于20整数', duration: 2000 })
              return false
            }
          }
          // 平均泌乳
          if (this.create.temp.avgdim !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.avgdim))) {
              this.$message({ type: 'error', message: '平均泌乳天数请输入正整数', duration: 2000 })
              return false
            }
          }
          // 产奶量
          if (this.create.temp.product !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.product))) {
              this.$message({ type: 'error', message: '产奶量请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳脂率
          if (this.create.temp.fat !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.fat))) {
              this.$message({ type: 'error', message: '乳脂率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳蛋白率
          if (this.create.temp.pro !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.pro))) {
              this.$message({ type: 'error', message: '乳蛋白率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳糖率
          if (this.create.temp.lactose !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.lactose))) {
              this.$message({ type: 'error', message: '乳糖率请保留两位小数', duration: 2000 })
              return false
            }
          }

          this.requestParam.name = 'updateBarmilk'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.cowsum == '') { this.create.temp.cowsum = '0' }
          if (this.create.temp.tem == '') { this.create.temp.tem = '0' }
          if (this.create.temp.avgmonthage == '') { this.create.temp.avgmonthage = '0' }
          if (this.create.temp.bw == '') { this.create.temp.bw = '0' }
          if (this.create.temp.dayw == '') { this.create.temp.dayw = '0' }
          if (this.create.temp.dayspre == '') { this.create.temp.dayspre = '0' }
          if (this.create.temp.fetal == '') { this.create.temp.fetal = '0' }
          if (this.create.temp.avgdim == '') { this.create.temp.avgdim = '0' }
          if (this.create.temp.product == '') { this.create.temp.product = '0' }
          if (this.create.temp.fat == '') { this.create.temp.fat = '0' }
          if (this.create.temp.pro == '') { this.create.temp.pro = '0' }
          if (this.create.temp.lactose == '') { this.create.temp.lactose = '0' }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.get_table_data()
            } else {
              failproccess(response, this.$notify)
              if (this.create.temp.dayspre == '0') { this.create.temp.dayspre = '' }
              if (this.create.temp.fetal == '0') { this.create.temp.fetal = '' }
              if (this.create.temp.cowsum == '0') { this.create.temp.cowsum = '' }
              if (this.create.temp.avgdim == '0') { this.create.temp.avgdim = '' }
            }
          })
        }
      })
    },

    // 删除
    form_delete(row) {
      console.log('点击了行内删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam.name = 'deleteBarmilk'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.get_table_data()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    change_table_selection(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    handleDelete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择栏舍生产性能', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList } }
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = {            'name': 'deleteBarmilk', 'type': 'e', 'parammaps': {
              id: '@insertSpotList.id',
              pastureid: '@insertSpotList.pastureid'
            }          }
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.get_table_data()
            }
          })
        })
      }
    },
    // 复制
    handleCopy() {
      console.log('点击了复制')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择栏舍生产性能', duration: 2000 })
      } else if (this.selectList.length == 1) {
        MessageBox.confirm('是否确认复制此信息?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          this.requestParam.name = 'copybarmilk'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.pastureid = this.selectList[0].pastureid
          this.requestParam.parammaps.id = this.selectList[0].id
          PostDataByName(this.requestParam).then(response => {
            if (response.msg === 'fail') {
              const barid = new RegExp("key 'barid'")
              if (barid.test(response.data)) {
                this.$message({ type: 'error', message: '该栏舍今日生产性能已存在，不可重复生成', duration: 2000 })
              } else {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              }
            } else {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.get_table_data()
            }
          })
        }).catch(() => {
          this.$message({ type: 'info', message: '已取消删除' })
        })
      } else {
        this.$message({ type: 'error', message: '请选择一条栏舍生产性能', duration: 2000 })
      }
    },
    // 导出
    form_export(item) {
      if (item == 1) {
        console.log('点击了导出模板')
      } else {
        console.log('点击了导出数据')
      }
    },

    // 导入
    form_inport() {
      console.log('点击了导入')
    }

  }
}
</script>
<style lang="scss" scoped>
.search {
  padding-top: 10px;
  clear: both;
}
.table {
  margin-top: 10px;
}
</style>
